/*----------------------------------------------------------------------
 * This source distribution and its contents are (c) 2011 Gregory Perry, 
 * and are released under the GNU Public License Version 3.  Portions of
 * this distribution were borrowed from the msieve project.
 *
 * For more information visit the main CloudCrack page at:
 * http://www.GoVirtual.tv/CloudCrack/
 *
 * Become of fan and engage in discussions at the CloudCrack Fan Page:
 * https://www.facebook.com/pages/CloudCrack/156984984362011/
 *
 * Or, send an email to Gregory.Perry@GoVirtual.tv
 *
 * $Id$
 * --------------------------------------------------------------------*/

#ifndef _CUDARHO_PRIV_H_
#define _CUDARHO_PRIV_H_

#include <cudarho.h>

#ifdef __cplusplus
extern "C" {
#endif

int32 mont_cmp(uint32 *a, uint32 stride_a,
       		uint32 *b, uint32 stride_b);

uint32 mont_add(uint32 *a, uint32 stride_a,
		uint32 *b, uint32 stride_b,
		uint32 *c, uint32 stride_c);

void mont_sub(uint32 *a, uint32 stride_a,
		uint32 *b, uint32 stride_b,
		uint32 *c, uint32 stride_c);

void montmul(uint32 *a, uint32 *b, uint32 *scratch,
		uint32 stride, uint32 *n, uint32 w);

void gcd(uint32 *a, uint32 *b, uint32 stride);

#ifdef __cplusplus
}
#endif

#endif /* !_CUDARHO_PRIV_H_ */
